#!/bin/bash

case "$1" in
  r)
    cat "$2" | sed -n "s/^[ \s]*$3[ \s]*[=]*[ \s]*//p" | head -n1 | sed -e "s/\"//g"
    ;;
  w)
    if [[ $3 == *=* ]];then
      key=`echo $3 | cut -f1 -d'='`
      val=`echo $3 | cut -f2 -d'='`
    else
      key=$3
      val=""
    fi
    if [ "$key" = "" ];then
      echo error
    elif [ "$val" = "" ];then
      ### read
      cat "$2" | sed -n "s/^[ \s]*$key[ \s]*[=]*[ \s]*//p" | head -n1 | sed -e "s/\"//g"
    else
      ### write
      line=`grep  -nE "^\s*$key(\s|=)+" "$2" | head -n1 |sed -e 's/:.*//g'`
      echo $2 $key $val $line
      sed -i -e "$line s/\(^\s*$key\s*[\s|=|\"]\{1\}\s*\)[^\"]*\(\"*\)/\1$val\2/" "$2"
      sync
    fi
    ;;

  isolate)
    systemd-run --nice=19 systemctl stop spotifyd
    systemd-run --nice=19 systemctl stop shairport-sync
    sleep 0.4
    ;;

  stop-avahi)
    systemd-run --nice=19 systemctl stop avahi-daemon
    systemd-run --nice=19 systemctl stop avahi-daemon.socket
    sleep 0.4
    ;;

  pause)
    if [ "`pidof shairport-sync`" = "" ];then
        systemctl start avahi-daemon.socket
        systemctl start shairport-sync
    fi
    if [ "`pidof spotifyd`" = "" ];then
        systemd-run /home/pi/misc/ympd_event.sh spotifyd-start
    fi
    ;;

  spotifyd-start)
    sleep 2
    systemctl start spotifyd
    ;;

  stop)
    if [ $(mpc|grep "\[playing\]"|wc -l) = 1 -o  $(mpc|grep "\[paused\]"|wc -l) = 1 ];then
        exit
    fi

    if [ "`pidof shairport-sync`" = "" ];then
        systemctl start avahi-daemon.socket
        systemctl start avahi-daemon
        systemctl start shairport-sync
        systemd-run /home/pi/misc/ympd_event.sh spotifyd-start
    fi
    ;;

  browse)
    ls /var/lib/mpd/music/RAM/* >/dev/null 2>&1
    if [ $? -eq 0 ]; then
        mpc update RAM
    fi
    ;;

  dashboard)
    /home/pi/util-plot.sh
    /home/pi/util-dashboard.sh
    ;;

esac

exit
